#include <iostream>
#include <algorithm>

using namespace std;


int euclid(int a, int b) {
    if (a == b) return a;
    if (a == 1 or b == 1) return 1;

    if (b > a) swap(a, b);
    while (a % b) {
        a %= b;
        swap(a, b);
    }

    return b;
}


int main() {
    int n, q;
    cin >> n >> q;

    int a[n];
    for (int i = 0; i < n; ++i) cin >> a[i];

    int b[n];
    for (int i = 0; i < n; ++i) cin >> b[i];

    int c[q];
    for (int i = 0; i < q; ++i) cin >> c[i];

    pair <int, int> d[n * n];
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            d[i * n + j] = {a[i], b[j]};

    sort(d, d + n*n, [] (const pair<int,int>& a, const pair<int,int>& b)
    {return double(a.first) / double(a.second) < double(b.first) / double(b.second);});

    for (int i = 0; i < q; ++i) {
        int nod = euclid(d[c[i]-1].first, d[c[i]-1].second);
        cout << d[c[i]-1].first / nod << ' ' << d[c[i]-1].second / nod << '\n';
    }

    return 0;
}
